/*********************************************************************
 *  ____                      _____      _                           *
 * / ___|  ___  _ __  _   _  | ____|_ __(_) ___ ___ ___  ___  _ __   *
 * \___ \ / _ \| '_ \| | | | |  _| | '__| |/ __/ __/ __|/ _ \| '_ \  *
 *  ___) | (_) | | | | |_| | | |___| |  | | (__\__ \__ \ (_) | | | | *
 * |____/ \___/|_| |_|\__, | |_____|_|  |_|\___|___/___/\___/|_| |_| *
 *                    |___/                                          *
 *                                                                   *
 *********************************************************************
 * Copyright 2010 Sony Ericsson Mobile Communications AB.            *
 * All rights, including trade secret rights, reserved.              *
 *********************************************************************/

package com.sonyericsson.eventstream.facebookplugin.runners;

import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestApplication;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestCredentialHandler;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestDatabase;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestDeepLinking;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestFacebook;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestListener;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestSecurity;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestService;
import com.sonyericsson.eventstream.facebookplugin.UFacebookPluginTestSettings;

import android.test.InstrumentationTestRunner;
import android.test.InstrumentationTestSuite;

import junit.framework.TestSuite;

public class UnitTestRunner extends InstrumentationTestRunner {

    @Override
    public TestSuite getAllTests() {
        TestSuite suite = new InstrumentationTestSuite(this);

        suite.addTestSuite(UFacebookPluginTestCredentialHandler.class);
        suite.addTestSuite(UFacebookPluginTestDatabase.class);
        suite.addTestSuite(UFacebookPluginTestDeepLinking.class);
        suite.addTestSuite(UFacebookPluginTestFacebook.class);
        suite.addTestSuite(UFacebookPluginTestListener.class);
        suite.addTestSuite(UFacebookPluginTestSecurity.class);
        suite.addTestSuite(UFacebookPluginTestService.class);
        suite.addTestSuite(UFacebookPluginTestSettings.class);
        suite.addTestSuite(UFacebookPluginTestApplication.class);

        return suite;
    }

    @Override
    public ClassLoader getLoader() {
        return UnitTestRunner.class.getClassLoader();
    }
}
