/*********************************************************************
 *  ____                      _____      _                           *
 * / ___|  ___  _ __  _   _  | ____|_ __(_) ___ ___ ___  ___  _ __   *
 * \___ \ / _ \| '_ \| | | | |  _| | '__| |/ __/ __/ __|/ _ \| '_ \  *
 *  ___) | (_) | | | | |_| | | |___| |  | | (__\__ \__ \ (_) | | | | *
 * |____/ \___/|_| |_|\__, | |_____|_|  |_|\___|___/___/\___/|_| |_| *
 *                    |___/                                          *
 *                                                                   *
 *********************************************************************
 * Copyright 2010 Sony Ericsson Mobile Communications AB.            *
 * All rights, including trade secret rights, reserved.              *
 *********************************************************************/

package com.sonyericsson.eventstream.telephonyplugin.runners;

import com.sonyericsson.eventstream.telephonyplugin.UEventStreamListener;
import com.sonyericsson.eventstream.telephonyplugin.UOriginatedSourceHelper;
import com.sonyericsson.eventstream.telephonyplugin.UTelephonyPluginLaunchViewTests;
import com.sonyericsson.eventstream.telephonyplugin.UTelephonyPluginTests;

import android.test.InstrumentationTestRunner;
import android.test.InstrumentationTestSuite;

import junit.framework.TestSuite;

public class UnitTestRunner extends InstrumentationTestRunner {

    @Override
    public TestSuite getAllTests() {
        TestSuite suite = new InstrumentationTestSuite(this);
        suite.addTestSuite(UEventStreamListener.class);
        suite.addTestSuite(UOriginatedSourceHelper.class);
        suite.addTestSuite(UTelephonyPluginTests.class);
        suite.addTestSuite(UTelephonyPluginLaunchViewTests.class);
        return suite;
    }

    @Override
    public ClassLoader getLoader() {
        return UnitTestRunner.class.getClassLoader();
    }
}
